//var apiUrl = "http://dev-api.lingmall.com/";
var apiUrl = "http://saas-api.lingmall.com/";
var hasLoginKey = "haslogin";
var tokenKey = "access_token";
var refreshKey = "refresh_token"
var currentProviceKey = "currentProvince";
var currentCityKey = "currentCity";
var myposition = "myposition";
var protext = "限时火拼";
//{\"access_token\":\"token\",\"refresh_token\":\"token\",\"expirestime\":3600,\"uuid\":"12"}

var offset = 0;
var limit = 10;

var showOrderCount = 2; //订单商品最多显示2个

var imgSize = {
	thumb50: "thumbnail50", //"    thumbnail50      无水印，75% 质量",
	thumb100: "thumbnail100", //"    thumbnail100     无水印，75% 质量",
	thumb300: "thumbnail300", //"    thumbnail300     无水印，75% 质量",
	thumb500: "thumbnail500", //"    thumbnail500     零猫水印，75% 质量",
	thumb1000: "thumbnail1000", //"    thumbnail1000    零猫水印，75% 质量",
	hq500: "hq500", //"    hq500            无水印，100% 质量",
	hq1000: "hq1000" //"    hq1000           无水印，100% 质量",
};

var loginBody = {
	"grant_type": "password",
	"client_id": "f3d259ddd3ed8ff3843839b",
	"client_secret": "4c7f6f8fa93d59c45502c0ae8c4a95b",
	"username": "",
	"password": ""
};

/***
 * 判断字符串是否为空
 * @param {Object} str
 */
function isEmpty(str) {
	if(str == null || str == undefined || str.replace(/(^s*)|(s*$)/g, "").length == 0) {
		return true;
	}
	return false;
}

function isEmptyPassword(str) {
	if(str == null || str == undefined || str.replace(/(^s*)|(s*$)/g, "").length == 0) {
		return true;
	} else {
		var reg = /[a-z0-9]{6,16}/;
		if(str.match(reg) == null) {
			return true;
		} else {
			return false;
		}
	}
}

function isEmptyMobile(str) {
	if(str == null || str == undefined || str.replace(/(^s*)|(s*$)/g, "").length == 0) {
		return true;
	} else {
		var reg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1}))+\d{8})$/;
		if(str.match(reg) == null) {
			return true;
		} else {
			return false;
		}
	}
}

/***
 * 获取token
 */
function getAccess_token() {
	var access_token = JSON.parse(plus.storage.getItem(tokenKey)).access_token;
}

/***
 * 发送验证码
 * @param {Object} mobile
 * @param {Object} type  1:注册验证码 2:找回密码验证码
 */
function sendMsg(mobile, type) {
	var urlName = "";
	if(type == 1) {
		urlName = "sms/register";
	} else if(type == 2) {
		urlName = "sms/get_back_password";
	}

	mui.ajax(apiUrl + urlName, {
		data: JSON.stringify({
			"mobile": parseInt(mobile)
		}),
		dataType: "json",
		headers: {
			'Content-Type': 'application/json'
		},
		type: "post",
		beforeSend: function() {
			plus.nativeUI.showWaiting("正在发送验证码..", {});
		},
		complete: function() {
			plus.nativeUI.closeWaiting();
		},
		success: function(result) {
			console.log(JSON.stringify(result));
			if(result.code == "0") {
				var data = result.data;
				plus.nativeUI.alert("验证码已经发送，请注意查收");
				//mui.back();
			} else {
				plus.nativeUI.alert(result.message);
			}
		},
		error: function(xhr, type, errorThrown) {
			console.log(JSON.stringify(xhr));
			if(getErrorState(xhr)) {
				var response = JSON.parse(xhr.response);
				plus.nativeUI.alert(response.message);
			}
		}
	});
}

/***
 * 将时间毫秒转化成日期字符串
 * @param {Object} dateTime
 */
function formatTime(dateTime) {
	if(!!!dateTime)
		return "";
	var date = new Date(parseInt(dateTime.replace("/Date(", "").replace(")/", ""), 10));
	var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
	var currentDate = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();
	var hour = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
	var min = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
	return date.getFullYear() + "-" + month + "-" + currentDate + " " + hour + ":" + min;
};

/***
 * 查找数组中是否存在
 * @param {Object} arrayToSearch
 * @param {Object} stringToSearch
 */
function in_array(arrayToSearch, stringToSearch) {
	for(s = 0; s < arrayToSearch.length; s++) {
		thisEntry = arrayToSearch[s].toString();
		if(thisEntry == stringToSearch) {
			return true;
		}
	}
	return false;
}

/***
 * 根据订单状态得到状态名
 * @param {Object} orderState
 */
function getOrderStateName(orderState) {
	var text = "";
	switch(orderState) {
		case 0:
			text = "已取消";
			break;
		case 1:
			text = "待支付";
			break;
		case 2:
			text = "待发货";
			break;
		case 3:
			text = "已发货";
			break;
		case 4:
			text = "已收货";
			break;
		case 5:
			text = "已结单";
			break;
		default:
			text = "未知";
			break;
	}
	return text;
}

/***
 * 高端的rest非200提示
 * @param {Object} xhr
 */
function getErrorState(xhr) {
	return parseInt(xhr.status / 100) == 4;
}

/***
 * 去拼(进入商品详情页)
 * @param {Object} groupon_sku_id
 */
function toBuy(groupon_sku_id, isIndexPage) {
	var href = 'product-details.html';
	var productDetailPage = plus.webview.getWebviewById(href);

	plus.nativeUI.showWaiting("正在加载中..", {});
	//延迟处理
	setTimeout(function() {
		mui.fire(productDetailPage, 'getProductDetail', {
			groupon_sku_id: groupon_sku_id
		});
	}, 1000);
	setTimeout(function() {

		if(isIndexPage == 0) {
			mui.back();
		}
		mui.openWindow({
			url: href,
			id: href,
			show: {
				aniShow: 'slide-in-right',
			},
			waiting: {
				autoShow: true, //自动显示等待框，默认为true
				title: '正在加载...', //等待对话框上显示的提示内容

			}
		});
		plus.nativeUI.closeWaiting();
	}, 2000);
}

/***
 * 统一提示方法
 * @param {Object} msg
 */
function showAlert(msg) {
	plus.nativeUI.alert(msg);
}

/***
 * 显示最长多少字符，多则省略
 * @param {Object} str
 * @param {Object} len
 */
function showFixString(str, len) {
	if(str && str.length > 0) {
		return str.length > len ? str.substr(0, len) + "..." : str;
	} else {
		return "";
	}
}

//取出字符串中的?后面的参数
function getParamByString(str, name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	var r = str.substr(str.indexOf("?")).substr(1).match(reg);
	if(str != null) return unescape(r[2]);
	return null;
}

/***
 * 验证库存和发货地
 * @param {Object} verifyData
 * @param {Object} successCallBack
 */
function stockVerify(verifyData, verify_data2, successCallBack, callBackParam) {

	var tokenObj = JSON.parse(plus.storage.getItem(tokenKey));
	var access_token = tokenObj.access_token;
	var verifyData = verifyData;
	//var sku_id=this.getAttribute("data-skuid");
	//var count=this.value;
	//	verify_data.push({
	//		"sku_id":sku_id,
	//		"count":parseInt( this.value)
	//	});

	var verify_data2 = verify_data2;
	console.log("验证数据" + JSON.stringify(verifyData));

	mui.ajax(apiUrl + "warehouses/warehouse_skus/actions/verify?access_token=" + access_token, {
		data: JSON.stringify(verifyData),
		dataType: "json",
		headers: {
			'Content-Type': 'application/json'
		},
		type: "post",
		beforeSend: function() {
			plus.nativeUI.showWaiting("正在验证库存及发货地中..", {});
		},
		complete: function() {
			plus.nativeUI.closeWaiting();
		},
		success: function(result) {
			console.log(JSON.stringify(result));
			if(result.code == "0") {
				//验证成功生成订单
				//toOrder();
				//				if(successCallBack){
				//					successCallBack(callBackParam);
				//				}else{
				//					console.log("回调函数没有赋值");
				//				}
				stockgroupVerify(tokenObj, verify_data2, successCallBack, callBackParam);
			} else {
				plus.nativeUI.alert(result.message);
			}
		},
		error: function(xhr, type, errorThrown) {
			console.log(JSON.stringify(xhr));
			errFunction(xhr);
		}
	});
}

function stockgroupVerify(tokenObj, verify_data2, successCallBack, callBackParam) {
	var tokenObj = JSON.parse(plus.storage.getItem(tokenKey));
	var access_token = tokenObj.access_token;
	var verify_data2 = verify_data2;
	console.log(access_token);
	console.log(JSON.stringify(verify_data2));
	mui.ajax(apiUrl + "groupons/groupon_skus/actions/verify?access_token=" + access_token, {
		data: JSON.stringify(verify_data2),
		dataType: "json",
		headers: {
			'Content-Type': 'application/json'
		},
		type: "post",
		beforeSend: function() {
			plus.nativeUI.showWaiting("正在验证起订量及活动时间..", {});
		},
		complete: function() {
			plus.nativeUI.closeWaiting();
		},
		success: function(result) {
			console.log(JSON.stringify(result));
			if(result.code == "0") {
				//验证成功生成订单
				//toOrder();
				if(successCallBack) {
					successCallBack(callBackParam);
				} else {
					console.log("回调函数没有赋值");
				}
			} else {
				plus.nativeUI.alert(result.message);
			}
		},
		error: function(xhr, type, errorThrown) {
			console.log(JSON.stringify(xhr));
			errFunction(xhr);
		}
	});
}
/***
 * 通用登陆超时方法
 */
function errFunction(xhr) {
	if(getErrorState(xhr)) {
		var response = JSON.parse(xhr.response);
		if(response.code == 2013) {
			showAlert("登录已超时，请重新登录");
			plus.storage.removeItem(hasLoginKey);
			mui.openWindow({
				url: 'login.html',
				id: 'login.html',
				show: {
					aniShow: 'slide-in-right'
				},
			});
		} else {
			showAlert(response.message);
		}

	}
}

/*刷新token*/
function refleshtoken(callback) {
	var tokenObj = JSON.parse(plus.storage.getItem(tokenKey));
	var refresh_token = tokenObj.refresh_token;
	console.log(refresh_token);
	var refreshData={
		grant_type:'refresh_token',
		refresh_token:refresh_token,
		client_id:'f3d259ddd3ed8ff3843839b',
		client_secret:'4c7f6f8fa93d59c45502c0ae8c4a95b'
	};
	console.log(JSON.stringify(refreshData));
	mui.ajax(apiUrl + "user_login/refresh_token", {
			data: refreshData,
			dataType: "json",
//			headers: {
//				'Content-Type': 'application/json'
//			},
			type: "post",
			success: function(result) {
				console.log(JSON.stringify(result));
				if(result.code == "0") {
					var data = result.data;
					var oldTokenData=plus.storage.getItem(tokenKey);
					var oldTokenObj=JSON.parse(oldTokenData);
					oldTokenObj.access_token=data.access_token;
					oldTokenObj.refresh_token=data.refresh_token;
					oldTokenObj.expirestime=data.expires_in;
					
					plus.storage.setItem(hasLoginKey, "1");
					plus.storage.setItem(tokenKey, JSON.stringify(oldTokenObj));
					if(callback){
						callback();
					}
				} else {
					plus.nativeUI.alert(result.message);
				}
			},
			error: function(xhr, type, errorThrown) {
//				console.log(JSON.stringify(xhr.code));
//				console.log(type+"====="+errorThrown);
				plus.nativeUI.alert("请先登录");
					mui.openWindow({
						url: 'login.html',
						id: 'login.html',
						show: {
							aniShow: 'slide-in-right'
						},
					});
			}
		})
	}




function toUrl(myurl, isIndexPage) {
	var href = 'other.html';
	var otherPage = plus.webview.getWebviewById(href);

	plus.nativeUI.showWaiting("正在加载中..", {});
	setTimeout(function() {
		if(isIndexPage == 0) {
			mui.back();
		}
		mui.openWindow({
			url: href,
			id: href,
			show: {
				aniShow: 'slide-in-right',
			},
			waiting: {
				autoShow: true, //自动显示等待框，默认为true
				title: '正在加载...', //等待对话框上显示的提示内容

			},
			extras:{
				myurl:myurl
			}
		});
		plus.nativeUI.closeWaiting();
	}, 2000);
}




function refreshPrice(order,domtotal,callback,domgood,domfare){
			var tokenObj= JSON.parse(plus.storage.getItem(tokenKey));
			var access_token=tokenObj.access_token;
			var buyer_company_id=parseInt(tokenObj.company_id);
				
			var curOrderInfo=order;
			var orderGoodsData={
				access_token:access_token,
				company_id:buyer_company_id
			};
			console.log(JSON.stringify(order));
			mui.ajax(apiUrl+"aggregator/orders/groupon_orders/"+curOrderInfo.order_id,{
				data:orderGoodsData,
				dataType:"json",
				contentType:"application/x-www-form-urlencoded; charset=utf-8", 
				type:"get",
				success:function(result){
					console.log(JSON.stringify(result))
					if(result && result.code=="0"){
						var orderInfo=result.data.order_info;
						if(domgood!=null){
							//商品总额
							mui("#"+domgood)[0].innerHTML=orderInfo.goods_total_pric;
							mui("#"+domtotal)[0].innerHTML=orderInfo.total_price;
							//运费总额=订单总额-商品总额
							mui("#"+domfare)[0].innerHTML=''+( parseFloat(orderInfo.total_price)-parseFloat(orderInfo.goods_total_pric) ).toFixed(2);
							console.log(mui("#"+domtotal)[0].innerHTML);
						
							
						}else{
							domtotal = orderInfo.total_price;
							console.log(domtotal);
						}
							if(callback){
								callback();
							}
					}else{
						plus.nativeUI.alert(result.message);
					}
				},				
				error:function(xhr,type,errorThrown){
					console.log(JSON.stringify(xhr));
		
				}
			});
		}
		//数组中删除指定对象
		var deletewebview = function(arr,index){
			for (var i = 0; i<arr.length; i++) {
			    if(arr[i].id == index) {
					arr.splice(i, 1);
					break;
				}
			}
		}